---
title: The add-on bar
slug: Mozilla/Firefox/Releases/4/The_add-on_bar
tags:
  - Add-ons
  - Extensions
  - Firefox 4
  - Guide
  - NeedsExample
  - Toolbar
---
<div>{{FirefoxSidebar}}</div><p>{{ fx_minversion_header("4") }}</p>
<p>Firefox 4 eliminates the status bar from the bottom of the browser window in favor of a new toolbar located at the bottom of the window. This new toolbar, with the ID "addon-bar", is a standard XUL {{ XULElem("toolbar") }}; add-ons can insert content into it, and the user can drag buttons into it while customizing their toolbars. This is the primary difference between the add-on bar and the old status bar; you can now put any XUL element into it, since it's a standard toolbar.</p>
<div class="note">
 <strong>Note:</strong> For the time being, there is a status bar shim included so that add-ons that expect the status bar to be present will still work.</div>
<h2 id="Adding_an_element_to_the_add-on_bar">Adding an element to the add-on bar</h2>
<p>The add-on bar is an XUL toolbar with the ID "addon-bar". The code below locates the most-recently used window and adds a new item to the add-on bar that displays the text "Hello world!" using an XUL {{ XULElem("label") }} element.</p>
<pre class="brush: js">// Find the most recently used window

var mediator = Components.classes['@mozilla.org/appshell/window-mediator;1']
                  .getService(Components.interfaces.nsIWindowMediator);
var doc = mediator.getMostRecentWindow("navigator:browser").document;

// Get the add-on bar for that window

var addonBar = doc.getElementById("addon-bar");

// Construct the new toolbar item

var newItem = doc.createElement("toolbaritem");
var itemLabel = doc.createElement("label");

// Add the item to the toolbar and set its text label

newItem.appendChild(itemLabel);
addonBar.appendChild(newItem);
itemLabel.value = "Hello world!";
</pre>
<p>To add the button only once, create a bool pref to check if it is the first run. <a class="external" href="http://stackoverflow.com/questions/4978188/how-do-i-detect-a-first-run-in-firefox-a-addon/4978512#4978512">For example</a>:</p>
<pre class="brush: js">var firstrun = Services.prefs.getBoolPref("extensions.YOUREXT.firstrun");

var curVersion = "0.0.0";

if (firstrun) {
  Services.prefs.setBoolPref("extensions.YOUREXT.firstrun", false);
  Services.prefs.setCharPref("extensions.YOUREXT.installedVersion", curVersion);
  /* Code related to firstrun */
} else {
  try {
    var installedVersion = Services.prefs.getCharPref("extensions.YOUREXT.installedVersion");
    if (curVersion &gt; installedVersion) {
      Services.prefs.setCharPref("extensions.YOUREXT.installedVersion", curVersion);
      /* Code related to upgrade */
    }
  } catch (ex) {
    /* Code related to a reinstall */
  }
}
</pre>
<h2 id="How_to_use_one_overlay_per_Firefox_version">How to use one overlay per Firefox version</h2>
<p>Adding support for the add-on bar while staying compatible with Firefox 3.6 and older will require using two overlays.<br>
 The <a href="/en/Chrome_Registration" title="en/chrome_registration">chrome.manifest</a> file can specify which file is used by which Firefox version by using <a href="/en/Chrome_Registration#Manifest_flags" title="en/chrome_registration#Manifest_flags">manifest flags</a>:</p>
<pre>overlay chrome://browser/content/browser.xul chrome://myaddon/content/myaddon/overlayold.xul application={ec8030f7-c20a-464f-9b0e-13a3a9e97384} appversion&lt;4.0
overlay chrome://browser/content/browser.xul chrome://myaddon/content/myaddon/overlay.xul application={ec8030f7-c20a-464f-9b0e-13a3a9e97384} appversion&gt;=4.0
</pre>
<p>Note: the appversion has to be at least 2 digits long or it won't work with versions of Gecko before 1.8.0.13 and 1.8.1.5.</p>
<h3 class="editable" id="Adding_a_button_by_default">Adding a button by default</h3>
<p>See: <a href="/en/Code_snippets/Toolbar#Adding_button_by_default" title="en/Code_snippets/Toolbar#Adding_button_by_default">Adding a button by default</a></p>
<h2 id="Appearance_differences">Appearance differences</h2>
<ul>
 <li>Since the browser no longer occupies a large percentage of the bar with status information, the entire area is available for add-ons to use.</li>
 <li>The add-on bar is empty and hidden by default; the user must elect to make it visible.</li>
 <li>If a restartless add-on installs itself to the add-on bar directly and the bar is not already visible, the bar becomes visible automatically.</li>
 <li>If uninstalling a restartless add-on makes the number of items in the add-on bar become zero, the bar is hidden automatically.</li>
</ul>
<h2 id="See_also">See also</h2>
<ul>
 <li>The <a class="external" href="http://mike.kaply.com/2011/01/25/the-firefox-4-add-on-bar-for-developers">Firefox 4 add-on bar for developers</a>, by Mike Kaply</li>
</ul>
